% Benchmark excution time of SLS and SSF
% set1
imSrcName = '../lib/SLS/source.jpg'; % 400 x 265, ssf: 241s, SLS: 5193s
imTgtName = '../lib/SLS/target.jpg';

% set2
imSrcName='./MiddleBury/other-data/Dimetrodon/frame10.png'; % 640 x 480, ssf: 10m, SLS: unable
imTgtName='./MiddleBury/other-data/Dimetrodon/frame11.png';
im1 = imread(imSrcName); im2 = imread(imTgtName);
im1 = imresize(im1, 0.7); im2 =imresize(im2, 0.2);

% Run ssf
addpath('code/ssf');
ssf_setup;
conf = ssf_conf();

t1=tic;
[cFlow, scaleLabel, energylist, iter] = ssf(im1, im2, conf);
toc(t1)

addpath('code/include/SLS');
addpath('code/include/SiftFlow/release');
imSrc=im1;
imTgt=im2;

% the following functions are a part of the SIFT-Flow distribution
% and are not included in the SLS demo.
SIFTflowpara.alpha=2;
SIFTflowpara.d=40;
SIFTflowpara.gamma=0.005;
SIFTflowpara.nlevels=4;
SIFTflowpara.wsize=5;
SIFTflowpara.topwsize=20;
SIFTflowpara.nIterations=60;

% By default this code produces the same descriptors used in the paper. 
% Use 'pcareduced' instead of 'paper' for PCA reduced SIFT descriptors 
% See help extract_scalelessdescs for more options
t2=tic;
[descSrc, descTgt] = extract_scalelessdescs(imSrc, imTgt, 'paper'); 
[vx,vy,~] = SIFTflowc2f(descSrc, descTgt, SIFTflowpara);
toc(t2)