function scaleLabel = MRF_scale(dataterm, beta, tau)
    % MRF_scale Compute scale label for each pixel
    % use maximum likelihood, or MAP
    % dataterm stores matching cost for each scale, smaller is better
	scaleLabel = MAP_label(dataterm, 1./beta, tau./beta);
end

function label = maximum_likelihood_label(dataterm) %#ok<DEFNU>
    [~, label] = min(dataterm, [], 3);
end

function labelIndex = MAP_label(dataterm, lambda, disc_k)
    % MAP_LABEL
    % disc_k = 200; % this is not in effect, label difference is too small
    % choose robust parameter based on data distribution
    % data_k = 100; % reduce the effect of mismatched pixel, value is double
    data_k = less_percent(dataterm, 0.3);
    % lambda = 0.05; % the smaller, the smoother
    % lambda = 0.01; % very smooth
    % lambda = 0.05; % this parameter should be tuned
    labelIndex = mexLabel3(dataterm, [disc_k, data_k, lambda]); 
    labelIndex = labelIndex+1; % matlab is start from index 1
end

function num = less_percent(data_point, percent)
    % choose the percent small number from data_point
    % eg: [1:10], 30%, choose 3
    data_point = sort(data_point(:));
    [v, ~] = sort(data_point);
    num = v(round(length(v) * percent));
end
